clear_interrupts MACRO
 MOVE.w  #$700,D0                        ; Dsactive toutes les
 TRAP    #1                              ; interruptions masquables
 ENDM


restore_interrupts MACRO
 MOVE.w  #0,D0                           ; Active toutes les interruptions masquables
 TRAP    #1                              ; en dsarmant les bits 8, 9 et 10 de SR
 ENDM

wait_key MACRO
;***  Paramtres :
;                  \1 pour diffrencier les labels
Wait_Key_\1
 MOVE.B   $1b(a6),D0
 CMPI.B   #$FF,D0
 BNE.S Wait_Key_\1
 ENDM

get_key MACRO
 MOVE.w  #%1111111011111111,$600018      ; Masque les lignes sauf celle
                                         ; correspondant  [Esc]
 NOP                                     ; On attend pour ...
 NOP                                     ; ... laisser le temps ...
 NOP                                     ; ...  la TI-92 ...
 NOP                                     ; ... de prendre en ...
 NOP                                     ; ... compte les ...
 NOP                                     ; ... venements hardware
; BTST.b  #6,$60001B                      ; on teste la colonne de [Esc]

 move.l $60001C,d0
 move.l #0,d1
 move.l #0,d2
 move.l #7,d4
 jsr hexlib::put_bin

 asl.l  #8,d0
 move.l #1,d1
 move.l #0,d2
 move.l #7,d4
 jsr hexlib::put_bin

 asl.l  #8,d0
 move.l #2,d1
 move.l #0,d2
 move.l #7,d4
 jsr hexlib::put_bin
 asl.l  #8,d0
 move.l #3,d1
 move.l #0,d2
 move.l #7,d4
 jsr hexlib::put_bin

; move.w  #%0111111111111111,d0
; move.w  #7,d1
;next_key_line:
; MOVE.w  d0,$600018                      ; Masque aucunes des lignes
; NOP                                     ; On attend pour ...
; NOP                                     ; ... laisser le temps ...
; NOP                                     ; ...  la TI-92 ...
; NOP                                     ; ... de prendre en ...
; NOP                                     ; ... compte les ...
; NOP                                     ; ... venements hardware
; ror.w #1,d0

; move.l #7,d4
; jsr hexlib::put_bin

; subq.w #1,d1
; bmi next_key_line

; wait_key key

 ENDM

quit_if_on_pressed MACRO
 BTST.b  #1,$60001A      ; la touche [ON] est appuye ?
 BNE     no_ON           ; oui la touche [ON] est appuye
 jmp \1                  ; instruction  effectuer si vrai
no_ON:                   ; label si [ON] est appuye
 ENDM